## salmon 1.2.1+ds1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)

if(DEFINED ENV{CC})
  set(CC $ENV{CC})
else()
  set(CC gcc)
endif()
message("CC: ${CC}")

set(CC_VERSION "")
if(${CC} MATCHES ^gcc-)
  string(REGEX REPLACE "gcc-" "" CC_VERSION ${CC})
endif()
message("CC version: ${CC_VERSION}")

enable_testing()

project(Salmon)

option(USE_SHARED_LIBS "Use shared instead of static libraries" OFF)

# auto-populate version:
# from https://stackoverflow.com/questions/47066115/cmake-get-version-from-multi-line-text-file
file(READ "current_version.txt" ver)

string(REGEX MATCH "VERSION_MAJOR ([0-9]*)" _ ${ver})
set(ver_major ${CMAKE_MATCH_1})

string(REGEX MATCH "VERSION_MINOR ([0-9]*)" _ ${ver})
set(ver_minor ${CMAKE_MATCH_1})

string(REGEX MATCH "VERSION_PATCH ([0-9]*)" _ ${ver})
set(ver_patch ${CMAKE_MATCH_1})

set(CPACK_PACKAGE_VERSION_MAJOR ${ver_major})
set(CPACK_PACKAGE_VERSION_MINOR ${ver_minor})
set(CPACK_PACKAGE_VERSION_PATCH ${ver_patch})

set(CPACK_PACKAGE_VERSION "${ver_major}.${ver_minor}.${ver_patch}")
message("version: ${CPACK_PACKAGE_VERSION}")

set(PROJECT_VERSION ${CPACK_PACKAGE_VERSION})
set(CPACK_GENERATOR "TGZ")
set(CPACK_SOURCE_GENERATOR "TGZ")
set(CPACK_PACKAGE_VENDOR "University of Maryland")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "Salmon - Wicked-fast RNA-seq isoform quantification using selective alignment")
set(CPACK_PACKAGE_NAME
  "${CMAKE_PROJECT_NAME}-${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}")
set(CPACK_SOURCE_PACKAGE_FILE_NAME
  "${CMAKE_PROJECT_NAME}-${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}-Source")

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/Modules/")

# Set a default build type if none was specified
set(default_build_type "Release")

if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  message(STATUS "Setting build type to '${default_build_type}' as none was specified.")
  set(CMAKE_BUILD_TYPE "${default_build_type}" CACHE
      STRING "Choose the type of build." FORCE)
  # Set the possible values of build type for cmake-gui
  #set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS
  #  "Debug" "Release")
endif()

message(STATUS "CMAKE_BUILD_TYPE = ${CMAKE_BUILD_TYPE}")

## Set the standard required compile flags
# Nov 18th --- removed -DHAVE_CONFIG_H
set(REMOVE_WARNING_FLAGS "-Wno-unused-function;-Wno-unused-local-typedefs")
set(TGT_COMPILE_FLAGS "-ftree-vectorize;-funroll-loops;-fPIC;-fomit-frame-pointer;-O3;-DNDEBUG;-DSTX_NO_STD_STRING_VIEW")
set(TGT_WARN_FLAGS "-Wall;-Wno-unknown-pragmas;-Wno-reorder;-Wno-unused-variable;-Wreturn-type;-Werror=return-type;${REMOVE_WARNING_FLAGS}")
#set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fsanitize=address")
#set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=address")

###
# Sanitizers BEGIN
###
if (ASAN_BUILD)
  list(APPEND TGT_COMPILE_FLAGS "-fsanitize=address")
#list(APPEND TGT_COMPILE_FLAGS "-fsanitize=undefined")
#set(CMAKE_LINK_FLAGS "-fsanitize=address")
#list(APPEND CMAKE_LINK_FLAGS "-fsanitize=undefined")
  set(ASAN_LIB "asan")
else()
  set(ASAN_LIB "")
endif()
###
# Sanitizers END
###

if(APPLE)
set(WARNING_IGNORE_FLAGS "-Wno-deprecated-register")
list(APPEND TGT_WARN_FLAGS -Wno-deprecated-register)
else()
set(WARNING_IGNORE_FLAGS "")
endif()

## Prefer static to dynamic libraries
if(NOT USE_SHARED_LIBS)
  set(CMAKE_FIND_LIBRARY_SUFFIXES .a ${CMAKE_FIND_LIBRARY_SUFFIXES})
  set(MALLOC_STATIC_BUILD_FLAG "--enable-static")
endif()

include(CheckIPOSupported)

set(THREADS_PREFER_PTHREAD_FLAG ON)
find_package(Threads REQUIRED)

set(ICU_LIBS "")
set(ICU_INC_DIRS "")

set(CMAKE_CXX_STANDARD 14)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)
set(CXXSTDFLAG "-std=c++14")
set(GCCVERSION "5.2")

if(CONDA_BUILD)
  message("Building with CONDA_BUILD flag")
  if(APPLE)
    # Do we require all these components?  Any others?
    find_package(ICU COMPONENTS data i18n io uc REQUIRED)
    if(ICU_FOUND)
      message(STATUS "ICU_INCLUDE_DIRS = ${ICU_INCLUDE_DIRS}")
      message(STATUS "ICU_LIBRARIES = ${ICU_LIBRARIES}")
    endif()
    set(ICU_INC_DIRS ${ICU_INCLUDE_DIRS})
    set(ICU_LIBS ${ICU_LIBRARIES})
  endif()
endif()

set(BOOST_CXX_FLAGS "${WARNING_IGNORE_FLAGS} ${CXXSTDFLAG}")
if(FETCH_BOOST)
  set(BOOST_CXX_FLAGS "${BOOST_CXX_FLAGS} -I${CMAKE_CURRENT_SOURCE_DIR}/external/install/include -L${CMAKE_CURRENT_SOURCE_DIR}/external/install/lib")
endif()

##
# OSX is strange (some might say, stupid in this regard).  Deal with it's quirkines here.
##
if(APPLE)
  # To allow ourselves to build a dynamic library, we have to tell the compiler
  # that, yes, the symbols will be around at runtime.
  list(APPEND TGT_COMPILE_FLAGS "-undefined dynamic_lookup;-Wno-unused-command-line-argument")
  # set(LIBSALMON_LINKER_FLAGS "-all_load")
  # In order to "think different", we also have to use non-standard suffixes
  # for our shared libraries
  set(SHARED_LIB_EXTENSION "dylib")
else()
  # We're in sane linux world
  set(SHARED_LIB_EXTENSION "so")
  set(LIBSALMON_LINKER_FLAGS "")
endif()

set( BOOST_EXTRA_FLAGS "--layout=tagged" )
## this get's set differently below if we
## are on clang & apple
set(NON_APPLECLANG_LIBS gomp)

if(UNIX AND NOT APPLE)
  set(LIBRT rt)
endif()

set(PTHREAD_LIB)

##
# Let us check the sha sum of our pacakges if we have the right tools
##
set(SHASUM ${CMAKE_CURRENT_SOURCE_DIR}/scripts/check_shasum.sh)

##
# Compiler-specific C++11/14 activation.
# http://stackoverflow.com/questions/10984442/how-to-detect-c11-support-of-a-compiler-with-cmake
##
##
# First take care of what to do if we have gcc
##
if("${CMAKE_CXX_COMPILER_ID}" MATCHES "GNU")
  execute_process(
    COMMAND ${CMAKE_CXX_COMPILER} -dumpversion OUTPUT_VARIABLE GCC_VERSION)
    # If we're on OSX
    if(APPLE AND NOT (GCC_VERSION VERSION_GREATER ${GCCVERSION} OR GCC_VERSION VERSION_EQUAL ${GCCVERSION}))
      message(FATAL_ERROR "When building under OSX, ${PROJECT_NAME} requires "
                            "either clang or g++ >= ${GCCVERSION}")
    elseif(NOT (GCC_VERSION VERSION_GREATER ${GCCVERSION} OR GCC_VERSION VERSION_EQUAL ${GCCVERSION}))
      message(FATAL_ERROR "${PROJECT_NAME} requires g++ ${GCCVERSION} or greater.")
    endif()
    
    if(GCC_VERSION VERSION_GREATER_EQUAL "7.1")
      list(APPEND TGT_WARN_FLAGS "-Wno-int-in-bool-context")
    endif()
    
    if(GCC_VERSION VERSION_GREATER_EQUAL "9.1")
      list(APPEND TGT_WARN_FLAGS "-Wno-deprecated-copy")
    endif()

    set(GCC TRUE)

    # Put complete static linking on hold for the time-being
    # If we're not on OSX, make an attempt to compile everything statically
    #if(NOT APPLE)
    #set(CMAKE_EXE_LINK_FLAGS "-static")
    set(PTHREAD_LIB "pthread")
    #endif()

    # If we're on Linux (i.e. not OSX) and we're using
    # gcc, then set the -static-libstdc++ flag
    if(NOT APPLE)
        list(APPEND TGT_COMPILE_FLAGS -static-libstdc++)
    endif()

    set(WARNING_IGNORE_FLAGS "${WARNING_IGNORE_FLAGS} -Wno-unused-local-typedefs")
    set(BOOST_TOOLSET "${CC}")
    set(BOOST_CONFIGURE_TOOLSET "--with-toolset=gcc")
    set(BCXX_FLAGS "${CXXSTDFLAG}")
    set(BOOST_EXTRA_FLAGS toolset=${CC} cxxflags=${BCXX_FLAGS})
# Tentatively, we support clang now
elseif("${CMAKE_CXX_COMPILER_ID}" MATCHES "Clang")
    set(CLANG TRUE)
    # If we have libc++, then try and use it
    include(CheckCXXCompilerFlag)
    check_cxx_compiler_flag(-stdlib=libc++ HAVE_LIBCPP)
    if(HAVE_LIBCPP)
      message("It appears that you're compiling with clang and that libc++ is available, so I'll use that")
      list(APPEND TGT_COMPILE_FLAGS -stdlib=libc++)
      set(BOOST_TOOLSET "clang")
      set(BOOST_CONFIGURE_TOOLSET "--with-toolset=clang")
      set(BCXX_FLAGS "-stdlib=libc++ -DBOOST_HAS_INT128")
      set(BOOST_EXTRA_FLAGS toolset=clang cxxflags=${BCXX_FLAGS} linkflags="-stdlib=libc++")
    # Otherwise, use libstdc++ (and make it static)
    else()
      list(APPEND TGT_COMPILE_FLAGS -static-libstdc++)
    endif()
    # There's currently a bug with clang-3.4 & Boost 1.55 -- this hack fixes it
    # but we should do something better (does this break things if CPU doesn't
    # have 128-bit support)?
    list(APPEND TGT_COMPILE_FLAGS -DBOOST_HAS_INT128)

    if(APPLE)
      set(NON_APPLECLANG_LIBS "")
    else()
      set(PTHREAD_LIB "pthread")
    endif()
else()
  message(FATAL_ERROR "Your C++ compiler does not support C++14.")
endif()

if(DO_QUIET_MAKE)
  set(QUIET_MAKE "--silent")
else()
  set(QUIET_MAKE "")
endif()

## TODO: Figure out how to detect this automatically
# If the "assembler" is too old, tell TBB not to compile
# with -mrtm
if(NO_RTM)
  set(TBB_CXXFLAGS "-mno-rtm")
endif()

include(ExternalProject)

if(CMAKE_BUILD_TYPE MATCHES Debug)
  message("Making Debug build")
elseif(CMAKE_BUILD_TYPE MATCHES Release)
  message("Making Release build")
else()
  message("Making Default build type")
endif()

##
# Record this top-level path
##
set(GAT_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR})

# Have CMake tell us what it's doing
# set(CMAKE_VERBOSE_MAKEFILE true)

###
# check if numeric_limits<__int128_t> is defined
###
try_compile(HAVE_INT128_NUMERIC_LIMITS ${CMAKE_BINARY_DIR} 
            SOURCES ${GAT_SOURCE_DIR}/tests/compile_tests/int128_numeric_limits.cpp
            CXX_STANDARD 14
            CXX_STANDARD_REQUIRED ON 
            )
if(HAVE_INT128_NUMERIC_LIMITS)
  message("setting -DHAVE_NUMERIC_LIMITS128")
  list(APPEND TGT_COMPILE_FLAGS "-DHAVE_NUMERIC_LIMITS128")
else()
  message("not setting -DHAVE_NUMERIC_LIMITS128")
endif()

###
#
#  Grab pufferfish source --- DURING CONFIGURE TIME!
#
####
if(NOT FETCHED_PUFFERFISH)
  exec_program(${CMAKE_CURRENT_SOURCE_DIR}/scripts/fetchPufferfish.sh RETURN_VALUE FETCH_PF_SCRIPT_RET)
  message(STATUS "fetch PUFFERFISH exit code ${FETCH_PF_SCRIPT_RET}")
  if(NOT (FETCH_PF_SCRIPT_RET EQUAL 0))
    message(FATAL_ERROR "Could not fetch pufferfish source [fetchPufferfish.sh returned exit code ${FETCH_PF_SCRIPT_RET}].")
  endif()
  set(FETCHED_PUFFERFISH TRUE CACHE BOOL "Has pufferfish been fetched?" FORCE)
endif()

##
# Super-secret override
##
if( DEFINED CUSTOM_BOOST_PATH )
  set(CMAKE_INCLUDE_PATH ${CUSTOM_BOOST_PATH} ${CMAKE_INCLUDE_PATH})
  set(CMAKE_LIBRARY_PATH ${CUSTOM_BOOST_PATH}/lib ${CMAKE_LIBRARY_PATH})
endif()

##
# We want static, multithreaded boost libraries
##
if(CONDA_BUILD)
  set(Boost_USE_STATIC_LIBS OFF)
elseif(USE_SHARED_LIBS)   # CI failed when using an OR statement above...
  set(Boost_USE_STATIC_LIBS OFF)
else()
  set(Boost_USE_STATIC_LIBS ON)
endif()

set(Boost_USE_MULTITHREADED ON)
#set(Boost_USE_STATIC_RUNTIME OFF)
set(Boost_USE_DEBUG_RUNTIME OFF)

find_package(ZLIB)
if(NOT ZLIB_FOUND)
  message(FATAL_ERROR "zlib must be installed before configuration & building can proceed")
endif()

if("${CMAKE_INCLUDE_PATH}" STREQUAL "")
  set(EXTRA_CMAKE_INCLUDE_FLAGS "")
else()
  set(EXTRA_CMAKE_INCLUDE_FLAGS "-I${CMAKE_INCLUDE_PATH}")
endif()

if("${CMAKE_LIBRARY_PATH}" STREQUAL "")
  set(EXTRA_CMAKE_LIBRARY_FLAGS "")
else()
  set(EXTRA_CMAKE_LIBRARY_FLAGS "-L${CMAKE_LIBRARY_PATH}")
endif()

find_package(Iconv REQUIRED)
if(NOT Iconv_IS_BUILT_IN)
  set(ICONV_LIB Iconv::Iconv)
endif()

find_package(LibLZMA)
if(NOT LIBLZMA_FOUND)
  message("Will attempt to fetch and build liblzma")
  message("=======================================")
externalproject_add(liblzma
  DOWNLOAD_DIR ${CMAKE_CURRENT_SOURCE_DIR}/external
  ##
  DOWNLOAD_COMMAND curl -k -L http://tukaani.org/xz/xz-5.2.2.tar.gz -o xz-5.2.2.tar.gz &&
    ${SHASUM} 73df4d5d34f0468bd57d09f2d8af363e95ed6cc3a4a86129d2f2c366259902a2 xz-5.2.2.tar.gz &&
    tar -xzvf xz-5.2.2.tar.gz
  #URL http://tukaani.org/xz/xz-5.2.2.tar.gz
  #URL_HASH SHA1=14663612422ab61386673be78fbb2556f50a1f08
  ##
  SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/external/xz-5.2.2
  INSTALL_DIR ${CMAKE_CURRENT_SOURCE_DIR}/external/install
  BUILD_IN_SOURCE TRUE

=== src/CMakeLists.txt ===
include_directories(
${GAT_SOURCE_DIR}/include
${GAT_SOURCE_DIR}/include/eigen3
${GAT_SOURCE_DIR}/external
${GAT_SOURCE_DIR}/external/cereal/include
${GAT_SOURCE_DIR}/external/install/include
${ZLIB_INCLUDE_DIR}
${TBB_INCLUDE_DIRS}
${Boost_INCLUDE_DIRS}
${GAT_SOURCE_DIR}/external/install/include
${GAT_SOURCE_DIR}/external/install/include/pufferfish
${GAT_SOURCE_DIR}/external/install/include/pufferfish/digestpp
#${GAT_SOURCE_DIR}/external/install/include/rapmap
#${GAT_SOURCE_DIR}/external/install/include/rapmap/digestpp
${ICU_INC_DIRS}
)

set ( SALMON_MAIN_SRCS
EMUtils.cpp
CollapsedEMOptimizer.cpp
## PUFF_INTEGRATION
CollapsedCellOptimizer.cpp
##
CollapsedGibbsSampler.cpp
Salmon.cpp
BuildSalmonIndex.cpp
Graph.cpp
## PUFF_INTEGRATION
DedupUMI.cpp
Alevin.cpp
AlevinHash.cpp
SalmonAlevin.cpp
WhiteList.cpp
##
SalmonQuantify.cpp
FragmentLengthDistribution.cpp
FragmentStartPositionDistribution.cpp
# SequenceBiasModel.cpp
GZipWriter.cpp
SalmonQuantMerge.cpp
ProgramOptionsGenerator.cpp
)

set (SALMON_ALIGN_SRCS
FASTAParser.cpp
AlignmentModel.cpp
FragmentLengthDistribution.cpp
SalmonQuantifyAlignments.cpp
BAMUtils.cpp
)

set (ALEVIN_LIB_SRCS
  edlib.cpp
  AlevinUtils.cpp
)

set (SALMON_LIB_SRCS
${GAT_SOURCE_DIR}/src/jellyfish/mer_dna.cc
xxhash.c
TranscriptGroup.cpp
EffectiveLengthStats.cpp
LibraryFormat.cpp
GenomicFeature.cpp
VersionChecker.cpp
SBModel.cpp
FastxParser.cpp
StadenUtils.cpp
SalmonUtils.cpp
DistributionUtils.cpp
SalmonExceptions.cpp
SalmonStringUtils.cpp
SimplePosBias.cpp
SGSmooth.cpp
${GAT_SOURCE_DIR}/external/install/src/pufferfish/metro/metrohash64.cpp
)

# check if we know how to do IPO
check_ipo_supported(RESULT HAS_IPO)

if (DEFINED NO_IPO)
  message("NO_IPO = ${NO_IPO}")
else()
  message("NO_IPO = FALSE")
  set(NO_IPO FALSE)
endif()

if(HAS_IPO AND (NOT NO_IPO))
  set_property(TARGET ksw2pp PROPERTY INTERPROCEDURAL_OPTIMIZATION True)
endif()

set ( UNIT_TESTS_SRCS
    ${GAT_SOURCE_DIR}/tests/UnitTests.cpp
    FragmentLengthDistribution.cpp
    ${GAT_SOURCE_DIR}/external/install/src/pufferfish/rank9b.cpp
)


link_directories(
${GAT_SOURCE_DIR}/lib
${GAT_SOURCE_DIR}/external/install/lib
${Boost_LIBRARY_DIRS}
${TBB_LIBRARY_DIRS}
${LAPACK_LIBRARY_DIR}
${BLAS_LIBRARY_DIR}
)

message("TBB_LIBRARIES = ${TBB_LIBRARIES}")

# Set the RPATH
if (NOT APPLE)
    set(CMAKE_INSTALL_RPATH "$ORIGIN/../lib:$ORIGIN/../../lib:$ORIGIN/:$ORIGIN/../../external/install/lib")
    set(CMAKE_BUILD_WITH_INSTALL_RPATH TRUE)
else()
  # use, i.e. do not skip the full RPATH for the build tree
  set(CMAKE_SKIP_BUILD_RPATH  FALSE)

  # when building, don't use the install RPATH already
  # (but later on when installing)
  set(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE) 

  # the RPATH to be used when installing
  set(CMAKE_INSTALL_RPATH "")

  # don't add the automatically determined parts of the RPATH
  # which point to directories outside the build tree to the install RPATH
  set(CMAKE_INSTALL_RPATH_USE_LINK_PATH FALSE)
endif()


set (TGT_RELEASE_FLAGS "${TGT_COMPILE_FLAGS};${TGT_WARN_FLAGS}")
set (TGT_DEBUG_FLAGS "-g;${TGT_COMPILE_FLAGS};${TGT_WARN_FLAGS}")

# Build the Salmon library
add_library(salmon_core STATIC ${SALMON_LIB_SRCS} )
target_compile_definitions(salmon_core PUBLIC
RAPMAP_SALMON_SUPPORT=1
PUFFERFISH_SALMON_SUPPORT=1
HAVE_ANSI_TERM=1
HAVE_SSTREAM=1
STX_NO_STD_STRING_VIEW=1
span_FEATURE_MAKE_SPAN_TO_STD=14
)
target_compile_options(salmon_core PUBLIC "$<$<CONFIG:DEBUG>:${TGT_DEBUG_FLAGS}>")
target_compile_options(salmon_core PUBLIC "$<$<CONFIG:RELEASE>:${TGT_RELEASE_FLAGS}>")
if(HAS_IPO AND (NOT NO_IPO))
  set_property(TARGET salmon_core PROPERTY INTERPROCEDURAL_OPTIMIZATION True)
endif()

# Build the Alevin library
# PUFF_INTEGRATION
add_library(alevin_core STATIC ${ALEVIN_LIB_SRCS})
target_compile_definitions(alevin_core PUBLIC
RAPMAP_SALMON_SUPPORT=1
PUFFERFISH_SALMON_SUPPORT=1
HAVE_ANSI_TERM=1
HAVE_SSTREAM=1
span_FEATURE_MAKE_SPAN_TO_STD=14
)
target_compile_options(alevin_core PUBLIC "$<$<CONFIG:DEBUG>:${TGT_DEBUG_FLAGS}>")
target_compile_options(alevin_core PUBLIC "$<$<CONFIG:RELEASE>:${TGT_RELEASE_FLAGS}>")

if(HAS_IPO AND (NOT NO_IPO))
  set_property(TARGET alevin_core PROPERTY INTERPROCEDURAL_OPTIMIZATION True)
endif()

# Build the salmon executable
add_executable(salmon ${SALMON_MAIN_SRCS} ${SALMON_ALIGN_SRCS})

if(HAS_IPO AND (NOT NO_IPO))
  set_property(TARGET salmon PROPERTY INTERPROCEDURAL_OPTIMIZATION True)
endif()

add_executable(unitTests ${UNIT_TESTS_SRCS})

#add_executable(salmon-read ${SALMON_READ_SRCS})
#set_target_properties(salmon-read PROPERTIES COMPILE_FLAGS "${CMAKE_CXX_FLAGS} -DHAVE_LIBPTHREAD -D_PBGZF_USE -fopenmp"
#    LINK_FLAGS "-DHAVE_LIBPTHREAD -D_PBGZF_USE -fopenmp")

#set_target_properties(salmon_core salmon PROPERTIES LINK_SEARCH_END_STATIC TRUE)

# our suffix array construction libraries
#if(NOT LIBDIVSUFSORT_FOUND)
#  set (SUFFARRAY_LIB ${GAT_SOURCE_DIR}/external/install/lib/libdivsufsort.a)
#  set (SUFFARRAY_LIB64 ${GAT_SOURCE_DIR}/external/install/lib/libdivsufsort64.a)
#  message ("Setting libdivsufsort = ${SUFFARRAY_LIB}") 
#  message ("Setting libdivsufsort64 = ${SUFFARRAY_LIB64}") 
#endif()


# Link the executable
target_link_libraries(salmon
    Threads::Threads
    puffer 
    salmon_core
    twopaco
    graphdump
    ntcard
    gff
    ${Boost_LIBRARIES}
    ${ICU_LIBS}
    ${STADEN_LIBRARIES} ${CURL_LIBRARIES}
    ${ZLIB_LIBRARY}
    #${SUFFARRAY_LIB}
    #${SUFFARRAY_LIB64}
    #${GAT_SOURCE_DIR}/external/install/lib/libbwa.a
    m
    ${LIBLZMA_LIBRARIES}
    ${BZIP2_LIBRARIES}
    ${TBB_LIBRARIES}
    ${LIBSALMON_LINKER_FLAGS}
    ${NON_APPLECLANG_LIBS}
    ${FAST_MALLOC_LIB}
    ${LIBRT}
    ksw2pp
## PUFF_INTEGRATION    
    alevin_core
    ${CMAKE_DL_LIBS}
    ${ASAN_LIB}
    #ubsan
)

# Link the executable
target_link_libraries(unitTests
    Threads::Threads
## PUFF_INTEGRATION
    alevin_core
    salmon_core
    gff
    ${STADEN_LIBRARIES} 
    ${Boost_LIBRARIES}
    ${ICU_LIBS}
    ${CURL_LIBRARIES}
    ${ZLIB_LIBRARY}
    m
    ${LIBLZMA_LIBRARIES}
    ${BZIP2_LIBRARIES}
    ${TBB_LIBRARIES}
    ${LIBSALMON_LINKER_FLAGS}
    ${NON_APPLECLANG_LIBS}
    ${LIBRT}
    ${CMAKE_DL_LIBS}
    ${ASAN_LIB}
    #ubsan
)

if(NOT Iconv_IS_BUILT_IN)
  target_link_libraries(unitTests Iconv::Iconv)
  target_link_libraries(salmon Iconv::Iconv)
endif()

add_dependencies(salmon unitTests)

##
# External dependencies of salmon_core and salmon
##
if (${FETCHED_JEMALLOC})
   add_dependencies(alevin_core libjemalloc)
   add_dependencies(salmon_core libjemalloc)
   add_dependencies(salmon libjemalloc)
endif()

if (${FETCHED_BOOST})
## PUFF_INTEGRATION
#   add_dependencies(alevin_core libboost)
   add_dependencies(alevin_core libboost)
   add_dependencies(salmon_core libboost)
   add_dependencies(salmon libboost)
endif()

if (${FETCHED_TBB})
   add_dependencies(alevin_core libtbb)
   add_dependencies(salmon_core libtbb)
## PUFF_INTEGRATION
#   add_dependencies(alevin_core libtbb)
   add_dependencies(salmon libtbb)
endif()

if (${FETCHED_CEREAL})
  add_dependencies(alevin_core libcereal)
  add_dependencies(salmon_core libcereal)
  add_dependencies(salmon libcereal)
endif()

if (${FETCHED_STADEN})
## PUFF_INTEGRATION
#  add_dependencies(alevin_core libstadenio)
  add_dependencies(alevin_core libstadenio)
  add_dependencies(salmon_core libstadenio)
  add_dependencies(salmon libstadenio)
endif()

#add_dependencies(salmon_core libbwa)
#add_dependencies(salmon libbwa)

if (${FETCHED_GFF})
  add_dependencies(alevin_core libgff)
  add_dependencies(salmon_core libgff)
  add_dependencies(salmon libgff)
endif()

### No need for this, I think
##  This ensures that the salmon executable should work with or without `make install`
###
## Grumble grumble . . . OSX
#if (APPLE)
#    # only attempt install_name_tool for tbb if we installed it
#    if (${TBB_LIBRARY_DIRS} MATCHES ${GAT_SOURCE_DIR}/external/install/lib)
#        add_custom_command(TARGET salmon
#            POST_BUILD
#            COMMAND install_name_tool -change libtbb.dylib @rpath/libtbb.dylib ${GAT_SOURCE_DIR}/build/src/salmon
#            COMMAND install_name_tool -change libtbbmalloc.dylib @rpath/libtbbmalloc.dylib ${GAT_SOURCE_DIR}/build/src/salmon
#            COMMAND install_name_tool -change libtbbmalloc_proxy.dylib @rpath/libtbbmalloc_proxy.dylib ${GAT_SOURCE_DIR}/build/src/salmon
#            COMMAND install_name_tool -add_rpath  ${GAT_SOURCE_DIR}/external/install/lib ${GAT_SOURCE_DIR}/build/src/salmon
#            )
#        add_custom_command(TARGET unitTests
#            POST_BUILD
#            COMMAND install_name_tool -change libtbb.dylib @rpath/libtbb.dylib ${GAT_SOURCE_DIR}/build/src/unitTests
#            COMMAND install_name_tool -change libtbbmalloc.dylib @rpath/libtbbmalloc.dylib ${GAT_SOURCE_DIR}/build/src/unitTests
#            COMMAND install_name_tool -change libtbbmalloc_proxy.dylib @rpath/libtbbmalloc_proxy.dylib ${GAT_SOURCE_DIR}/build/src/unitTests
#            COMMAND install_name_tool -add_rpath  ${GAT_SOURCE_DIR}/external/install/lib ${GAT_SOURCE_DIR}/build/src/unitTests
#            )
#    endif()
#else()
#    # related to complete static linking --- on hold    
#    set (BOOST_THREAD_LIBRARY)
#endif()

#if (APPLE)
#	add_custom_command(TARGET salmon
#		POST_BUILD
#		COMMAND install_name_tool -add_rpath ${GAT_SOURCE_DIR}/external/install/lib salmon
#	COMMAND install_name_tool -add_rpath @executable_path/../lib salmon
#		)
#endif()

##### ======================================

IF(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
  SET(CMAKE_INSTALL_PREFIX
    "${GAT_SOURCE_DIR}" CACHE PATH "Default install prefix" FORCE
    )
ENDIF(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)

set(INSTALL_LIB_DIR lib )
set(INSTALL_BIN_DIR bin )
set(INSTALL_INCLUDE_DIR include )

install(DIRECTORY
        ${GAT_SOURCE_DIR}/external/install/lib/
        DESTINATION ${INSTALL_LIB_DIR}
	    FILES_MATCHING PATTERN "libtbb*.${SHARED_LIB_EXTENSION}*"
    )

# install(FILES ${Boost_LIBRARIES}
# 	           DESTINATION ${INSTALL_LIB_DIR})

install(TARGETS salmon salmon_core
                RUNTIME DESTINATION bin
                LIBRARY DESTINATION lib
                ARCHIVE DESTINATION lib
        )

add_custom_command(TARGET unitTests POST_BUILD
    COMMAND ${CMAKE_COMMAND} -E copy $<TARGET_FILE:unitTests> ${GAT_SOURCE_DIR}/tests/$<TARGET_FILE_NAME:unitTests>
    COMMENT "Copying unitTests"
)

set(POST_INSTALL_SCRIPT ${GAT_SOURCE_DIR}/cmake/PostInstall.cmake)

install(
    CODE
    "
    execute_process(COMMAND \"${CMAKE_COMMAND}\"
                            -DCMAKE_SYSTEM_NAME=${CMAKE_SYSTEM_NAME}
                            -DCMAKE_INSTALL_PREFIX=${CMAKE_INSTALL_PREFIX}
                            -P \"${POST_INSTALL_SCRIPT}\")
    "
)

include(InstallRequiredSystemLibraries)
add_test( NAME unit_tests COMMAND ${CMAKE_COMMAND} -DTOPLEVEL_DIR=${GAT_SOURCE_DIR} -P ${GAT_SOURCE_DIR}/cmake/UnitTests.cmake )
add_test( NAME salmon_read_test_quasi COMMAND ${CMAKE_COMMAND} -DTOPLEVEL_DIR=${GAT_SOURCE_DIR} -P ${GAT_SOURCE_DIR}/cmake/TestSalmonQuasi.cmake )

# Remove this test since we are removing support for the FMD index. 
# add_test( NAME salmon_read_test_fmd COMMAND ${CMAKE_COMMAND} -DTOPLEVEL_DIR=${GAT_SOURCE_DIR} -P ${GAT_SOURCE_DIR}/cmake/TestSalmonFMD.cmake )

=== debian/changelog ===
salmon (1.2.1+ds1-1build1) groovy; urgency=medium

  * No-change rebuild against libstaden-read14

 -- Graham Inggs <ginggs@ubuntu.com>  Sun, 21 Jun 2020 14:20:11 +0000

salmon (1.2.1+ds1-1) unstable; urgency=medium

  * New upstream version (Closes: #952102)
  * debhelper-compat 12
  * Standards-Version: 4.5.0 (routine-update)
  * Secure URI in copyright format (routine-update)
  * Respect DEB_BUILD_OPTIONS in override_dh_auto_test target (routine-
    update)
  * Set upstream metadata fields: Bug-Database, Bug-Submit.
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Thu, 23 Apr 2020 12:13:04 +0200

=== debian/control ===
Source: salmon
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Michael R. Crusoe <michael.crusoe@gmail.com>,
           Kevin Murray <spam@kdmurray.id.au>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 12),
               cmake,
               libboost-filesystem-dev,
               libboost-system-dev,
               libboost-iostreams-dev,
               libboost-thread-dev,
               libboost-program-options-dev,
               libboost-timer-dev,
               libjellyfish-2.0-dev (>> 2.2.3-2),
               libpthread-stubs0-dev,
               libsparsehash-dev,
               libdivsufsort-dev,
               libbwa-dev,
               pkg-config,
               libjemalloc-dev,
               libcereal-dev,
               libtbb-dev,
               libgff-dev,
               libstaden-read-dev,
               libspdlog-dev,
               libtclap-dev,
               help2man,
               sphinx-doc,
               python3-sphinx,
               python3-sphinx-rtd-theme,
               zlib1g-dev,
               libeigen3-dev,
               libbz2-dev,
               liblzma-dev,
               rapmap-dev
Standards-Version: 4.5.0
Vcs-Browser: https://salsa.debian.org/med-team/salmon
Vcs-Git: https://salsa.debian.org/med-team/salmon.git
Homepage: https://github.com/COMBINE-lab/salmon
Rules-Requires-Root: no

Package: salmon
Architecture: any
Built-Using: ${sphinxdoc:Built-Using}
Depends: ${shlibs:Depends},
         ${misc:Depends},
         ${sphinxdoc:Depends}
Description: wicked-fast transcript quantification from RNA-seq data
 Salmon is a wicked-fast program to produce a highly-accurate, transcript-level
 quantification estimates from RNA-seq data. Salmon achieves is accuracy and
 speed via a number of different innovations, including the use of lightweight
 alignments (accurate but fast-to-compute proxies for traditional read
 alignments) and massively-parallel stochastic collapsed variational inference.
 The result is a versatile tool that fits nicely into many different pipelines.
 For example, you can choose to make use of the lightweight alignments by
 providing Salmon with raw sequencing reads, or, if it is more convenient, you
 can provide Salmon with regular alignments (e.g. computed with your favorite
 aligner), and it will use the same wicked-fast, state-of-the-art inference
 algorithm to estimate transcript-level abundances for your experiment.

## salmon 1.3.0+ds1

=== CMakeLists.txt ===
--- 
+++ 
@@ -68,7 +68,7 @@
 ## Set the standard required compile flags
 # Nov 18th --- removed -DHAVE_CONFIG_H
 set(REMOVE_WARNING_FLAGS "-Wno-unused-function;-Wno-unused-local-typedefs")
-set(TGT_COMPILE_FLAGS "-ftree-vectorize;-funroll-loops;-fPIC;-fomit-frame-pointer;-O3;-DNDEBUG;-DSTX_NO_STD_STRING_VIEW")
+set(TGT_COMPILE_FLAGS "-ftree-vectorize;-funroll-loops;-fPIC;-fomit-frame-pointer;-O3;-DNDEBUG;-DSTX_NO_STD_STRING_VIEW;-D__STDC_FORMAT_MACROS")
 set(TGT_WARN_FLAGS "-Wall;-Wno-unknown-pragmas;-Wno-reorder;-Wno-unused-variable;-Wreturn-type;-Werror=return-type;${REMOVE_WARNING_FLAGS}")
 #set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fsanitize=address")
 #set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=address")

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -10,6 +10,7 @@
 ${GAT_SOURCE_DIR}/external/install/include
 ${GAT_SOURCE_DIR}/external/install/include/pufferfish
 ${GAT_SOURCE_DIR}/external/install/include/pufferfish/digestpp
+${LIB_GFF_INCLUDE_DIR}
 #${GAT_SOURCE_DIR}/external/install/include/rapmap
 #${GAT_SOURCE_DIR}/external/install/include/rapmap/digestpp
 ${ICU_INC_DIRS}
@@ -102,6 +103,7 @@
 ${TBB_LIBRARY_DIRS}
 ${LAPACK_LIBRARY_DIR}
 ${BLAS_LIBRARY_DIR}
+${LIB_GFF_LIBRARY_DIR}
 )
 
 message("TBB_LIBRARIES = ${TBB_LIBRARIES}")
@@ -206,16 +208,16 @@
     m
     ${LIBLZMA_LIBRARIES}
     ${BZIP2_LIBRARIES}
-    ${TBB_LIBRARIES}
     ${LIBSALMON_LINKER_FLAGS}
     ${NON_APPLECLANG_LIBS}
-    ${FAST_MALLOC_LIB}
-    ${LIBRT}
     ksw2pp
 ## PUFF_INTEGRATION    
     alevin_core
+    ${ASAN_LIB}
+    ${FAST_MALLOC_LIB}
+    ${TBB_LIBRARIES}
+    ${LIBRT}
     ${CMAKE_DL_LIBS}
-    ${ASAN_LIB}
     #ubsan
 )
 
@@ -237,9 +239,9 @@
     ${TBB_LIBRARIES}
     ${LIBSALMON_LINKER_FLAGS}
     ${NON_APPLECLANG_LIBS}
+    ${ASAN_LIB}
     ${LIBRT}
     ${CMAKE_DL_LIBS}
-    ${ASAN_LIB}
     #ubsan
 )

=== debian/changelog ===
salmon (1.3.0+ds1-3) unstable; urgency=medium

  * Team upload.
  * Architecture: any-amd64
    Closes: #966430

 -- Andreas Tille <tille@debian.org>  Fri, 14 Aug 2020 12:44:39 +0200

salmon (1.3.0+ds1-2) unstable; urgency=medium

  * Fix the build by adding a missing include.

 -- Michael R. Crusoe <crusoe@debian.org>  Tue, 28 Jul 2020 14:50:48 +0200

salmon (1.3.0+ds1-1) unstable; urgency=medium

  * Add a patch for portable pausing in spinlocks.
  * debian/upstream/metadata: link to upstream's repository
  * New upstream version
  * debhelper-compat 13 (routine-update)
  * kseq patch no longer needed
  * Refreshed remaining patches

 -- Michael R. Crusoe <crusoe@debian.org>  Thu, 16 Jul 2020 13:54:17 +0200

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,10 @@
 Source: salmon
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
-Uploaders: Michael R. Crusoe <michael.crusoe@gmail.com>,
+Uploaders: Michael R. Crusoe <crusoe@debian.org>,
            Kevin Murray <spam@kdmurray.id.au>
 Section: science
 Priority: optional
-Build-Depends: debhelper-compat (= 12),
+Build-Depends: debhelper-compat (= 13),
                cmake,
                libboost-filesystem-dev,
                libboost-system-dev,
@@ -21,7 +21,7 @@
                libjemalloc-dev,
                libcereal-dev,
                libtbb-dev,
-               libgff-dev,
+               libgff-dev (>> 2.0),
                libstaden-read-dev,
                libspdlog-dev,
                libtclap-dev,
@@ -41,7 +41,7 @@
 Rules-Requires-Root: no
 
 Package: salmon
-Architecture: any
+Architecture: any-amd64
 Built-Using: ${sphinxdoc:Built-Using}
 Depends: ${shlibs:Depends},
          ${misc:Depends},

## salmon 1.4.0+ds1

=== CMakeLists.txt ===
--- 
+++ 
@@ -16,6 +16,21 @@
 enable_testing()
 
 project(Salmon)
+
+# detect host architecture 
+if(NOT DEFINED USE_ARM)
+  if(CMAKE_SYSTEM_PROCESSOR MATCHES "^(aarch64.*|AARCH64.*|arm64.*|ARM64.*)")
+    message("Detected 64-bit ARM host. Setting USE_ARM to true.")
+    set(USE_ARM TRUE)
+    # set char to be signed
+    add_compile_options(-fsigned-char)
+    set(SCHAR_FLAG "-fsigned-char")
+  else()
+    message("Detected non-ARM host. Setting USE_ARM to false.")
+    set(USE_ARM FALSE)
+    set(SCHAR_FLAG "")
+  endif()
+endif()
 
 option(USE_SHARED_LIBS "Use shared instead of static libraries" OFF)
 
@@ -66,9 +81,8 @@
 message(STATUS "CMAKE_BUILD_TYPE = ${CMAKE_BUILD_TYPE}")
 
 ## Set the standard required compile flags
-# Nov 18th --- removed -DHAVE_CONFIG_H
 set(REMOVE_WARNING_FLAGS "-Wno-unused-function;-Wno-unused-local-typedefs")
-set(TGT_COMPILE_FLAGS "-ftree-vectorize;-funroll-loops;-fPIC;-fomit-frame-pointer;-O3;-DNDEBUG;-DSTX_NO_STD_STRING_VIEW;-D__STDC_FORMAT_MACROS")
+set(TGT_COMPILE_FLAGS "${SCHAR_FLAG};-ftree-vectorize;-funroll-loops;-fPIC;-fomit-frame-pointer;-O3;-DNDEBUG;-DSTX_NO_STD_STRING_VIEW;-D__STDC_FORMAT_MACROS")
 set(TGT_WARN_FLAGS "-Wall;-Wno-unknown-pragmas;-Wno-reorder;-Wno-unused-variable;-Wreturn-type;-Werror=return-type;${REMOVE_WARNING_FLAGS}")
 #set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fsanitize=address")
 #set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=address")
@@ -212,7 +226,7 @@
     set(WARNING_IGNORE_FLAGS "${WARNING_IGNORE_FLAGS} -Wno-unused-local-typedefs")
     set(BOOST_TOOLSET "${CC}")
     set(BOOST_CONFIGURE_TOOLSET "--with-toolset=gcc")
-    set(BCXX_FLAGS "${CXXSTDFLAG}")
+    set(BCXX_FLAGS "${CXXSTDFLAG} ${SCHAR_FLAG}")
     set(BOOST_EXTRA_FLAGS toolset=${CC} cxxflags=${BCXX_FLAGS})
 # Tentatively, we support clang now
 elseif("${CMAKE_CXX_COMPILER_ID}" MATCHES "Clang")
@@ -225,7 +239,7 @@
       list(APPEND TGT_COMPILE_FLAGS -stdlib=libc++)
       set(BOOST_TOOLSET "clang")
       set(BOOST_CONFIGURE_TOOLSET "--with-toolset=clang")
-      set(BCXX_FLAGS "-stdlib=libc++ -DBOOST_HAS_INT128")
+      set(BCXX_FLAGS "-stdlib=libc++ -DBOOST_HAS_INT128 ${SCHAR_FLAG}")
       set(BOOST_EXTRA_FLAGS toolset=clang cxxflags=${BCXX_FLAGS} linkflags="-stdlib=libc++")
     # Otherwise, use libstdc++ (and make it static)
     else()
@@ -358,11 +372,3 @@
   DOWNLOAD_DIR ${CMAKE_CURRENT_SOURCE_DIR}/external
   ##
   DOWNLOAD_COMMAND curl -k -L http://tukaani.org/xz/xz-5.2.2.tar.gz -o xz-5.2.2.tar.gz &&
-    ${SHASUM} 73df4d5d34f0468bd57d09f2d8af363e95ed6cc3a4a86129d2f2c366259902a2 xz-5.2.2.tar.gz &&
-    tar -xzvf xz-5.2.2.tar.gz
-  #URL http://tukaani.org/xz/xz-5.2.2.tar.gz
-  #URL_HASH SHA1=14663612422ab61386673be78fbb2556f50a1f08
-  ##
-  SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/external/xz-5.2.2
-  INSTALL_DIR ${CMAKE_CURRENT_SOURCE_DIR}/external/install
-  BUILD_IN_SOURCE TRUE

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -51,8 +51,9 @@
 )
 
 set (ALEVIN_LIB_SRCS
-  edlib.cpp
-  AlevinUtils.cpp
+edlib.cpp
+SingleCellProtocols.cpp
+AlevinUtils.cpp
 )
 
 set (SALMON_LIB_SRCS
@@ -142,6 +143,11 @@
 STX_NO_STD_STRING_VIEW=1
 span_FEATURE_MAKE_SPAN_TO_STD=14
 )
+
+if (USE_ARM)
+target_compile_definitions(salmon_core PUBLIC KSW_USE_ARM=1)
+endif()
+
 target_compile_options(salmon_core PUBLIC "$<$<CONFIG:DEBUG>:${TGT_DEBUG_FLAGS}>")
 target_compile_options(salmon_core PUBLIC "$<$<CONFIG:RELEASE>:${TGT_RELEASE_FLAGS}>")
 if(HAS_IPO AND (NOT NO_IPO))
@@ -158,6 +164,11 @@
 HAVE_SSTREAM=1
 span_FEATURE_MAKE_SPAN_TO_STD=14
 )
+
+if (USE_ARM)
+target_compile_definitions(alevin_core PUBLIC KSW_USE_ARM=1)
+endif()
+
 target_compile_options(alevin_core PUBLIC "$<$<CONFIG:DEBUG>:${TGT_DEBUG_FLAGS}>")
 target_compile_options(alevin_core PUBLIC "$<$<CONFIG:RELEASE>:${TGT_RELEASE_FLAGS}>")

=== debian/changelog ===
salmon (1.4.0+ds1-1) unstable; urgency=medium

  * New upstream version
  * Standards-Version: 4.5.1 (routine-update)
  * debian/patches/portable_pause: remove, applied upstream
  * debian/patches/spelling: remove, applied upstream
  * debian/patches/include_fix: remove, applied upstream
  * Refreshed remaining patches
  * debian/control: build-dep on libsimde-dev, build for arm64
  * debian/patches/spelling: new typo fixes

 -- Michael R. Crusoe <crusoe@debian.org>  Thu, 26 Nov 2020 19:10:46 +0100

=== debian/control ===
--- 
+++ 
@@ -33,15 +33,16 @@
                libeigen3-dev,
                libbz2-dev,
                liblzma-dev,
-               rapmap-dev
-Standards-Version: 4.5.0
+               rapmap-dev,
+               libsimde-dev
+Standards-Version: 4.5.1
 Vcs-Browser: https://salsa.debian.org/med-team/salmon
 Vcs-Git: https://salsa.debian.org/med-team/salmon.git
 Homepage: https://github.com/COMBINE-lab/salmon
 Rules-Requires-Root: no
 
 Package: salmon
-Architecture: any-amd64
+Architecture: any-amd64 arm64
 Built-Using: ${sphinxdoc:Built-Using}
 Depends: ${shlibs:Depends},
          ${misc:Depends},

## salmon 1.5.2+ds1

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -45,6 +45,8 @@
 set (SALMON_ALIGN_SRCS
 FASTAParser.cpp
 AlignmentModel.cpp
+ONTAlignmentModel.cpp
+AlignmentCommon.cpp
 FragmentLengthDistribution.cpp
 SalmonQuantifyAlignments.cpp
 BAMUtils.cpp
@@ -58,6 +60,7 @@
 
 set (SALMON_LIB_SRCS
 ${GAT_SOURCE_DIR}/src/jellyfish/mer_dna.cc
+backtrace.cc
 xxhash.c
 TranscriptGroup.cpp
 EffectiveLengthStats.cpp

=== debian/changelog ===
salmon (1.5.2+ds1-1) unstable; urgency=medium

  [ Steffen Moeller ]
  * Team upload.
  * Fix watchfile to detect new versions on github (routine-update)
  * New upstream version
  * Standards-Version: 4.6.0 (routine-update)
  * d/u/metadata: Added ref to SciCrunch (SCR_017036)

  [ Andreas Tille ]
  * Build-Depends: python3-docs-theme and use this instead of furo

 -- Andreas Tille <tille@debian.org>  Mon, 11 Oct 2021 09:38:42 +0200

=== debian/control ===
--- 
+++ 
@@ -29,13 +29,14 @@
                sphinx-doc,
                python3-sphinx,
                python3-sphinx-rtd-theme,
+               python3-docs-theme,
                zlib1g-dev,
                libeigen3-dev,
                libbz2-dev,
                liblzma-dev,
                rapmap-dev,
                libsimde-dev
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Vcs-Browser: https://salsa.debian.org/med-team/salmon
 Vcs-Git: https://salsa.debian.org/med-team/salmon.git
 Homepage: https://github.com/COMBINE-lab/salmon

## salmon 1.6.0+ds1

=== debian/changelog ===
salmon (1.6.0+ds1-1ubuntu2) kinetic; urgency=medium

  * debian/patches/glibc-2.34.patch: compatibility with glibc 2.34.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 20 Aug 2022 09:32:13 +0000

salmon (1.6.0+ds1-1ubuntu1) jammy; urgency=medium

  * Build-depend on libtbb2-dev instead of libtbb-dev.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 09 Mar 2022 12:07:23 +0100

salmon (1.6.0+ds1-1) unstable; urgency=medium

  * Team upload.
  * New upstream version

 -- Steffen Moeller <moeller@debian.org>  Mon, 13 Dec 2021 15:41:10 +0100

=== debian/control ===
--- 
+++ 
@@ -1,5 +1,6 @@
 Source: salmon
-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders: Michael R. Crusoe <crusoe@debian.org>,
            Kevin Murray <spam@kdmurray.id.au>
 Section: science
@@ -12,7 +13,7 @@
                libboost-thread-dev,
                libboost-program-options-dev,
                libboost-timer-dev,
-               libjellyfish-2.0-dev (>> 2.2.3-2),
+               libjellyfish-2.0-dev,
                libpthread-stubs0-dev,
                libsparsehash-dev,
                libdivsufsort-dev,
@@ -20,7 +21,7 @@
                pkg-config,
                libjemalloc-dev,
                libcereal-dev,
-               libtbb-dev,
+               libtbb2-dev,
                libgff-dev (>> 2.0),
                libstaden-read-dev,
                libspdlog-dev,
@@ -44,10 +45,10 @@
 
 Package: salmon
 Architecture: any-amd64 arm64
-Built-Using: ${sphinxdoc:Built-Using}
 Depends: ${shlibs:Depends},
          ${misc:Depends},
          ${sphinxdoc:Depends}
+Built-Using: ${sphinxdoc:Built-Using}
 Description: wicked-fast transcript quantification from RNA-seq data
  Salmon is a wicked-fast program to produce a highly-accurate, transcript-level
  quantification estimates from RNA-seq data. Salmon achieves is accuracy and

=== debian/watch ===
version=4

opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/salmon-$1\.tar\.gz/,dversionmangle=s/[~\+]ds[0-9]*//,repacksuffix=+ds1,repack,compression=xz \
https://github.com/COMBINE-lab/salmon/releases .*/v(\d[\d.-]+)\.(?:tar(?:\.gz|\.bz2)?|tgz)

## salmon 1.9.0+ds1

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -1,3 +1,7 @@
+if(${TBB_FOUND})
+  get_target_property(TBB_INCLUDE_DIRS TBB::tbb INTERFACE_INCLUDE_DIRECTORIES)
+endif()
+
 include_directories(
 ${GAT_SOURCE_DIR}/include
 ${GAT_SOURCE_DIR}/include/eigen3
@@ -93,10 +97,15 @@
   set_property(TARGET ksw2pp PROPERTY INTERPROCEDURAL_OPTIMIZATION True)
 endif()
 
-set ( UNIT_TESTS_SRCS
+set (UNIT_TESTS_ENTRY_SRCS
     ${GAT_SOURCE_DIR}/tests/UnitTests.cpp
-    FragmentLengthDistribution.cpp
-    ${GAT_SOURCE_DIR}/external/install/src/pufferfish/rank9b.cpp
+)
+
+set (UNIT_TESTS_INDIVIDUAL_SRCS
+  ${GAT_SOURCE_DIR}/src/FragmentLengthDistribution.cpp
+  ${GAT_SOURCE_DIR}/external/install/src/pufferfish/rank9b.cpp
+  ${GAT_SOURCE_DIR}/tests/GCSampleTests.cpp
+  ${GAT_SOURCE_DIR}/tests/LibraryTypeTests.cpp
 )
 
 
@@ -186,7 +195,13 @@
   set_property(TARGET salmon PROPERTY INTERPROCEDURAL_OPTIMIZATION True)
 endif()
 
-add_executable(unitTests ${UNIT_TESTS_SRCS})
+add_library(UnitTestsMain STATIC ${UNIT_TESTS_ENTRY_SRCS})
+target_compile_options(UnitTestsMain PUBLIC "$<$<CONFIG:DEBUG>:${TGT_DEBUG_FLAGS}>")
+target_compile_options(UnitTestsMain PUBLIC "$<$<CONFIG:RELEASE>:${TGT_RELEASE_FLAGS}>")
+
+add_executable(unitTests ${UNIT_TESTS_INDIVIDUAL_SRCS} ${GAT_SOURCE_DIR}/tests/catch.hpp)
+target_compile_options(unitTests PUBLIC "$<$<CONFIG:DEBUG>:${TGT_DEBUG_FLAGS}>")
+target_compile_options(unitTests PUBLIC "$<$<CONFIG:RELEASE>:${TGT_RELEASE_FLAGS}>")
 
 #add_executable(salmon-read ${SALMON_READ_SRCS})
 #set_target_properties(salmon-read PROPERTIES COMPILE_FLAGS "${CMAKE_CXX_FLAGS} -DHAVE_LIBPTHREAD -D_PBGZF_USE -fopenmp"
@@ -202,10 +217,17 @@
 #  message ("Setting libdivsufsort64 = ${SUFFARRAY_LIB64}") 
 #endif()
 
-
+add_dependencies(salmon puffer)
+add_dependencies(salmon twopaco)
+add_dependencies(salmon graphdump)
+add_dependencies(salmon ntcard)
+add_dependencies(salmon ksw2pp)
+add_dependencies(salmon salmon_core)
+add_dependencies(salmon alevin_core)
+if(TBB_RECONFIGURE OR TBB_TARGET_EXISTED)
 # Link the executable
 target_link_libraries(salmon
-    Threads::Threads
+    Threads::Threads 
     puffer 
     salmon_core
     twopaco
@@ -216,32 +238,41 @@
     ${ICU_LIBS}
     ${STADEN_LIBRARIES} ${CURL_LIBRARIES}
     ${ZLIB_LIBRARY}
-    #${SUFFARRAY_LIB}
-    #${SUFFARRAY_LIB64}
-    #${GAT_SOURCE_DIR}/external/install/lib/libbwa.a
     m
     ${LIBLZMA_LIBRARIES}
     ${BZIP2_LIBRARIES}
     ${LIBSALMON_LINKER_FLAGS}
     ${NON_APPLECLANG_LIBS}
     ksw2pp
-## PUFF_INTEGRATION    
     alevin_core
     ${ASAN_LIB}
     ${FAST_MALLOC_LIB}
-    ${TBB_LIBRARIES}
+    TBB::tbb
+    TBB::tbbmalloc
     ${LIBRT}
     ${CMAKE_DL_LIBS}
-    #ubsan
-)
-
-# Link the executable
+)
+endif()
+
+# dependencies for unitTests
+add_dependencies(salmon salmon_core)
+add_dependencies(salmon alevin_core)
+add_dependencies(unitTests UnitTestsMain)
+#add_dependencies(salmon puffer)
+#add_dependencies(salmon twopaco)
+#add_dependencies(salmon graphdump)
+#add_dependencies(salmon ntcard)
+#add_dependencies(salmon ksw2pp)
+
+if(TBB_RECONFIGURE OR TBB_TARGET_EXISTED)
+
 target_link_libraries(unitTests
     Threads::Threads
 ## PUFF_INTEGRATION
+    salmon_core
     alevin_core
-    salmon_core
     gff
+    UnitTestsMain
     ${STADEN_LIBRARIES} 
     ${Boost_LIBRARIES}
     ${ICU_LIBS}
@@ -250,7 +281,9 @@
     m
     ${LIBLZMA_LIBRARIES}
     ${BZIP2_LIBRARIES}
-    ${TBB_LIBRARIES}
+    #${TBB_LIBRARIES}
+    TBB::tbb
+    TBB::tbbmalloc
     ${LIBSALMON_LINKER_FLAGS}
     ${NON_APPLECLANG_LIBS}
     ${ASAN_LIB}
@@ -258,6 +291,7 @@
     ${CMAKE_DL_LIBS}
     #ubsan
 )
+endif()
 
 if(NOT Iconv_IS_BUILT_IN)
   target_link_libraries(unitTests Iconv::Iconv)
@@ -265,6 +299,8 @@
 endif()
 
 add_dependencies(salmon unitTests)
+add_dependencies(unitTests salmon_core)
+add_dependencies(unitTests alevin_core)
 
 ##
 # External dependencies of salmon_core and salmon
@@ -276,18 +312,16 @@
 endif()
 
 if (${FETCHED_BOOST})
-## PUFF_INTEGRATION
-#   add_dependencies(alevin_core libboost)
    add_dependencies(alevin_core libboost)
    add_dependencies(salmon_core libboost)
    add_dependencies(salmon libboost)
 endif()
 
 if (${FETCHED_TBB})
+   message("Fetched oneTBB, so libtbb must be a dependency for targets")
    add_dependencies(alevin_core libtbb)
    add_dependencies(salmon_core libtbb)
-## PUFF_INTEGRATION
-#   add_dependencies(alevin_core libtbb)
+   add_dependencies(unitTests libtbb)
    add_dependencies(salmon libtbb)
 endif()
 
@@ -361,41 +395,18 @@
 set(INSTALL_BIN_DIR bin )
 set(INSTALL_INCLUDE_DIR include )
 
-install(DIRECTORY
-        ${GAT_SOURCE_DIR}/external/install/lib/
-        DESTINATION ${INSTALL_LIB_DIR}
-	    FILES_MATCHING PATTERN "libtbb*.${SHARED_LIB_EXTENSION}*"
-    )
-
-# install(FILES ${Boost_LIBRARIES}
-# 	           DESTINATION ${INSTALL_LIB_DIR})
-
-install(TARGETS salmon salmon_core
-                RUNTIME DESTINATION bin
-                LIBRARY DESTINATION lib
-                ARCHIVE DESTINATION lib
-        )
-
-add_custom_command(TARGET unitTests POST_BUILD
-    COMMAND ${CMAKE_COMMAND} -E copy $<TARGET_FILE:unitTests> ${GAT_SOURCE_DIR}/tests/$<TARGET_FILE_NAME:unitTests>
-    COMMENT "Copying unitTests"
-)
-
-set(POST_INSTALL_SCRIPT ${GAT_SOURCE_DIR}/cmake/PostInstall.cmake)
-
-install(
-    CODE
-    "
-    execute_process(COMMAND \"${CMAKE_COMMAND}\"
-                            -DCMAKE_SYSTEM_NAME=${CMAKE_SYSTEM_NAME}
-                            -DCMAKE_INSTALL_PREFIX=${CMAKE_INSTALL_PREFIX}
-                            -P \"${POST_INSTALL_SCRIPT}\")
-    "
-)
-
-include(InstallRequiredSystemLibraries)
-add_test( NAME unit_tests COMMAND ${CMAKE_COMMAND} -DTOPLEVEL_DIR=${GAT_SOURCE_DIR} -P ${GAT_SOURCE_DIR}/cmake/UnitTests.cmake )
-add_test( NAME salmon_read_test_quasi COMMAND ${CMAKE_COMMAND} -DTOPLEVEL_DIR=${GAT_SOURCE_DIR} -P ${GAT_SOURCE_DIR}/cmake/TestSalmonQuasi.cmake )
-
-# Remove this test since we are removing support for the FMD index. 
-# add_test( NAME salmon_read_test_fmd COMMAND ${CMAKE_COMMAND} -DTOPLEVEL_DIR=${GAT_SOURCE_DIR} -P ${GAT_SOURCE_DIR}/cmake/TestSalmonFMD.cmake )
+if(TBB_RECONFIGURE OR TBB_TARGET_EXISTED)
+#set(TBB_SOURCE_DIR $<TARGET_FILE:TBB::tbb>)
+#add_custom_target(genexdebug COMMAND ${CMAKE_COMMAND} -E echo "$<TARGET_LINKER_FILE:TBB::tbb>")
+get_target_property(TBB_LIB_INSTALL_NAME TBB::tbb IMPORTED_LOCATION_RELEASE)
+get_filename_component(TBB_LIB_INSTALL_DIR ${TBB_LIB_INSTALL_NAME} DIRECTORY)
+message("TBB_LIB_INSTALL_DIR = ${TBB_LIB_INSTALL_DIR}")
+file(GLOB TBB_FILES ${TBB_LIB_INSTALL_DIR}/libtbb*.${SHARED_LIB_EXTENSION}*)
+message("TBBGLOBS = ${TBB_FILES}")
+
+install(FILES 
+  ${TBB_FILES}
+  DESTINATION ${INSTALL_LIB_DIR}
+) 
+#install(FILES 
+#  $<TARGET_FILE:TBB::tbbmalloc>

=== debian/changelog ===
salmon (1.9.0+ds1-1) unstable; urgency=medium

  [ Andreas Tille ]
  * Team upload.
  * New upstream version  (Closes: #1008254)

  [ Étienne Mollier ]
  * Standards-Version: 4.6.1 (routine-update)
  * Refresh use_debian_packaged_libs.patch, disable-version-check.patch and
    spelling patch.
  * d/external/: bump pufferfish version to support onetbb.  (Closes: #1011662)
  * d/external/: update twopaco to fix ftbfs with onetbb.
  * d/external/install/: update to reflect changes in embedded pufferfish.
  * Unvendor embedded cereal in embedded pufferfish.  (Closes: #1008252)
  * verbose-test.patch: make test failures more verbose.
  * d/salsa-ci.yml: disable run on i386

 -- Étienne Mollier <emollier@debian.org>  Sat, 05 Nov 2022 20:45:44 +0100
